ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.19 by root, Mon Dec 13 17:25:17 2010 UTC vs.
Revision 1.25 by root, Tue Dec 28 18:03:47 2010 UTC

6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
12PERL_CC=cc 13PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 17
17ARCH="$(uname -m)" 18ARCH="$(uname -m)"
18 19
19case "$ARCH" in 20case "$ARCH" in
20 i*86 | x86_64 | amd64 ) 21 i*86 | x86_64 | amd64 )
21 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
23 case "$ARCH" in 23 case "$ARCH" in
24 i*86 ) 24 i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 26 ;;
27 esac 27 esac
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
41 42
42# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
43# required by mkbundle 44# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 46
66 67
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 70
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side 72LC_ALL=C; export LC_ALL # just to be on the safe side
72 73
73# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
75$VERSION=0.911 76$VERSION=0.92
76 77
77BZ2=bz2 78BZ2=bz2
78BZIP2=bzip2 79BZIP2=bzip2
79 80
80fatal() { 81fatal() {
126 127
127clean() { 128clean() {
128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129} 130}
130 131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
136}
137
131fetch() { 138fetch() {
132 rcd "$STATICPERL" 139 rcd "$STATICPERL"
133 140
134 mkdir -p src 141 mkdir -p src
135 rcd src 142 rcd src
145perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
146trying $URL 153trying $URL
147EOF 154EOF
148 155
149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
152 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
153 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
154 fi 162 fi
155 163
156 verblock <<EOF 164 verblock <<EOF
157unpacking perl 165unpacking perl
158EOF 166EOF
159 167
160 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
161 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
162 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
163 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
164 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
165 rmdir -p unpack 174 rmdir -p unpack
167} 176}
168 177
169# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
170sedreplace() { 179sedreplace() {
171 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
172 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
173} 209}
174 210
175configure() { 211configure() {
176 fetch 212 fetch
177 213
183configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
184EOF 220EOF
185 221
186 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
187 223
188 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
189 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
190 # I hate them 228 # I hate them for this
191 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
192 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
193 231
194 preconfigure 232 preconfigure
195 233
201 -Uusethreads \ 239 -Uusethreads \
202 -Uuseithreads \ 240 -Uuseithreads \
203 -Uusemultiplicity \ 241 -Uusemultiplicity \
204 -Uusesfio \ 242 -Uusesfio \
205 -Uuseshrplib \ 243 -Uuseshrplib \
244 -A ccflags=" $PERL_CCFLAGS" \
206 -Dcc="$PERL_CC" \ 245 -Dcc="$PERL_CC" \
207 -Dcppflags="$PERL_CPPFLAGS" \
208 -Dccflags="-g2 -fno-strict-aliasing" \
209 -Doptimize="$PERL_OPTIMIZE" \ 246 -Doptimize="$PERL_OPTIMIZE" \
210 -Dldflags="$PERL_LDFLAGS" \ 247 -Dldflags="$PERL_LDFLAGS" \
211 -Dlibs="$PERL_LIBS" \ 248 -Dlibs="$PERL_LIBS" \
212 -Dprefix="$PERL_PREFIX" \ 249 -Dprefix="$PERL_PREFIX" \
213 -Dbin="$PERL_PREFIX/bin" \ 250 -Dbin="$PERL_PREFIX/bin" \
214 -Dprivlib="$PERL_PREFIX/lib" \ 251 -Dprivlib="$PERL_PREFIX/lib" \
215 -Darchlib="$PERL_PREFIX/lib" \ 252 -Darchlib="$PERL_PREFIX/lib" \
216 -Uusevendorprefix \ 253 -Uusevendorprefix \
217 -Dsitelib="$PERL_PREFIX/lib" \ 254 -Dsitelib="$PERL_PREFIX/lib" \
218 -Dsitearch="$PERL_PREFIX/lib" \ 255 -Dsitearch="$PERL_PREFIX/lib" \
219 -Usitelibexp \
220 -Uman1dir \ 256 -Uman1dir \
221 -Uman3dir \ 257 -Uman3dir \
222 -Usiteman1dir \ 258 -Usiteman1dir \
223 -Usiteman3dir \ 259 -Usiteman3dir \
224 -Dpager=/usr/bin/less \ 260 -Dpager=/usr/bin/less \
225 -Demail="$EMAIL" \ 261 -Demail="$EMAIL" \
226 -Dcf_email="$EMAIL" \ 262 -Dcf_email="$EMAIL" \
227 -Dcf_by="$EMAIL" \ 263 -Dcf_by="$EMAIL" \
228 $PERL_CONFIGURE \ 264 $PERL_CONFIGURE \
229 -Duseperlio \ 265 -Duseperlio \
230 -dE || fatal "Configure failed" 266 -dE || configure_failure
231 267
232 sedreplace ' 268 sedreplace '
233 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
234 s/ *-fno-stack-protector */ /g 270 s/ *-fno-stack-protector */ /g
235 ' config.sh 271 ' config.sh
250building $STATICPERL/src/perl-$PERL_VERSION 286building $STATICPERL/src/perl-$PERL_VERSION
251EOF 287EOF
252 288
253 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
254 290
255 make || fatal "make: error while building perl" 291 "$MAKE" || fatal "make: error while building perl"
256 292
257 postbuild || fatal "postbuild hook failed" 293 postbuild || fatal "postbuild hook failed"
258} 294}
259 295
260install() { 296install() {
270 ln -sf "perl/lib/" "$STATICPERL/lib" 306 ln -sf "perl/lib/" "$STATICPERL/lib"
271 307
272 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
273 rm -rf "$PERL_PREFIX" # by this rm -rf 309 rm -rf "$PERL_PREFIX" # by this rm -rf
274 310
275 make install || fatal "make install: error while installing" 311 "$MAKE" install || fatal "make install: error while installing"
276 312
277 rcd "$PERL_PREFIX" 313 rcd "$PERL_PREFIX"
278 314
279 # create a "make install" replacement for CPAN 315 # create a "make install" replacement for CPAN
280 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
281make || exit 317"$MAKE" || exit
282 318
283if find blib/arch/auto -type f | grep -q -v .exists; then 319if find blib/arch/auto -type f | grep -q -v .exists; then
284 echo Probably an XS module, rebuilding perl 320 echo Probably an XS module, rebuilding perl
285 if make perl; then 321 if "$MAKE" perl; then
286 mv perl "$PERL_PREFIX"/bin/perl 322 mv perl "$PERL_PREFIX"/bin/perl~ \
323 && rm -f "$PERL_PREFIX"/bin/perl \
324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
287 make -f Makefile.aperl map_clean 325 "$MAKE" -f Makefile.aperl map_clean
288 else 326 else
289 make -f Makefile.aperl map_clean 327 "$MAKE" -f Makefile.aperl map_clean
290 exit 1 328 exit 1
291 fi 329 fi
292fi 330fi
293 331
294make install UNINST=1 332"$MAKE" install UNINST=1
295EOF 333EOF
296 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
297 335
298 # trick CPAN into avoiding ~/.cpan completely 336 # trick CPAN into avoiding ~/.cpan completely
299 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
359 for mod in "$@"; do 397 for mod in "$@"; do
360 echo 398 echo
361 echo $mod 399 echo $mod
362 ( 400 (
363 rcd $mod 401 rcd $mod
364 make -f Makefile.aperl map_clean >/dev/null 2>&1 402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
365 make distclean >/dev/null 2>&1 403 "$MAKE" distclean >/dev/null 2>&1
366 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
367 make || fatal "$mod: error building module" 405 "$MAKE" || fatal "$mod: error building module"
368 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
369 make distclean >/dev/null 2>&1 407 "$MAKE" distclean >/dev/null 2>&1
370 exit 0 408 exit 0
371 ) || exit $? 409 ) || exit $?
372 done 410 done
373} 411}
374 412
422 command="${1#--}"; shift 460 command="${1#--}"; shift
423 case "$command" in 461 case "$command" in
424 version ) 462 version )
425 echo "staticperl version $VERSION" 463 echo "staticperl version $VERSION"
426 ;; 464 ;;
427 fetch | configure | build | install | clean | distclean) 465 fetch | configure | build | install | clean | realclean | distclean)
428 ( "$command" ) 466 ( "$command" ) || exit
429 ;; 467 ;;
430 instsrc ) 468 instsrc )
431 ( instsrc "$@" ) 469 ( instsrc "$@" ) || exit
432 exit 470 exit
433 ;; 471 ;;
434 instcpan ) 472 instcpan )
435 ( instcpan "$@" ) 473 ( instcpan "$@" ) || exit
436 exit 474 exit
437 ;; 475 ;;
438 cpan ) 476 cpan )
439 ( install ) 477 ( install ) || exit
440 "$PERL_PREFIX/bin/cpan" "$@" 478 "$PERL_PREFIX/bin/cpan" "$@"
441 exit 479 exit
442 ;; 480 ;;
443 mkbundle ) 481 mkbundle )
444 ( install ) 482 ( install ) || exit
445 bundle "$@" 483 bundle "$@"
446 exit 484 exit
447 ;; 485 ;;
448 mkperl ) 486 mkperl )
449 ( install ) 487 ( install ) || exit
450 bundle --perl "$@" 488 bundle --perl "$@"
451 exit 489 exit
452 ;; 490 ;;
453 mkapp ) 491 mkapp )
454 ( install ) 492 ( install ) || exit
455 bundle --app "$@" 493 bundle --app "$@"
456 exit 494 exit
457 ;; 495 ;;
458 help ) 496 help )
459 podusage 2 497 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines